%%JAFFE dataset
%main function to do the 200 rounding expression reocognition for compboost.
%author: Du, Liang (liang.du@temple.edu)
clear all; close all; clc
load('JAFFE.mat','task_data'); %task_data contains data and label for different tasks. 

numExp = 7;   %first 7 labels are for expressions with expression labels
numTask = length(task_data); 
numTotal = length(task_data{1}.label); % total number of faces; for here the same for all tasks.

for i = numExp+1 : numTask
    comp_labels(i-7) = {task_data{i}.label};
end
 

numTr = 60;  % number of training samples
nIter = 100;  %number of boosting iterations
lamada = 0.01; %free balancing parameters
 
round = 200;
accuracy_comp =  zeros(numExp,round); %for recording accuracy for each round
 

for rnd = 1 : round
    disp(['Training round: ',num2str(rnd)])
	%randomly generating training testing partition. 
	trIdx = randperm(numTotal, numTr);
	tstIdx = setdiff([1:numTotal],trIdx);   
   
    %%compboost  learning
       for t = 1 : numExp
            temp  = task_data{t}.data;
            data_cur = temp;
            temp = task_data{t}.label;
            label_cur = 2*temp-1;
           
            trData = data_cur(trIdx,:);
            trlabel = label_cur(trIdx);
                
            comp_model = compboost(trData,trlabel,comp_labels,nIter,lamada);%setting lamada = 0 will get ababoost results.
                
            tstData = data_cur(tstIdx ,:);
            tstlabel = label_cur(tstIdx);
            h_est = sign(eval_boost(tstData,comp_model));
            accuracy_comp(t,rnd) =  sum(h_est == tstlabel)/length(tstlabel);
        end
            
 end

 mean_accuracy = mean(mean(accuracy_comp)); % mean accuracy
         
     
    
 

