function [h] = eval_boost(X,model)
%evaluating the boost models.
%X--input feature matrix 
%model- cells with each a weak learner.
h = zeros(size(X,1),1);

sum_alpha = 0;
nModel = length(model);
for i=1:nModel
    if(isfield(model{i},'model'))
        h = h + model{i}.alpha*eval_stump(model{i}.model,X);  
    else
        h = h + model{i}.alpha*eval_stump(model{i},X);  
    end
    
    sum_alpha = sum_alpha + model{i}.alpha;
end;
